OGRE: Ogre::RenderQueue Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::RenderQueue Class Reference

Class to manage the scene object rendering queue. More...

`#include <OgreRenderQueue.h>`

List of all members.

## Public Types

typedef std::map< uint8, RenderQueueGroup * > | RenderQueueGroupMap
typedef MapIterator< RenderQueueGroupMap > | QueueGroupIterator
| Iterator over queue groups.

## Public Member Functions

| RenderQueue ()
virtual | ~RenderQueue ()
void | clear (bool destroyPassMaps=false)
| Empty the queue - should only be called by SceneManagers.
RenderQueueGroup * | getQueueGroup (uint8 qid)
| Get a render queue group.
void | addRenderable (Renderable *pRend, uint8 groupID, ushort priority)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend, uint8 groupId)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend)
| Add a renderable object to the queue.
uint8 | getDefaultQueueGroup (void) const
| Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
void | setDefaultRenderablePriority (ushort priority)
| Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
ushort | getDefaultRenderablePriority (void) const
| Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
void | setDefaultQueueGroup (uint8 grp)
| Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
QueueGroupIterator | _getQueueGroupIterator (void)
| Internal method, returns an iterator for the queue groups.
void | setSplitPassesByLightingType (bool split)
| Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.
void | setSplitNoShadowPasses (bool split)
| Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.
void | setShadowCastersCannotBeReceivers (bool ind)
| Sets whether or not objects which cast shadows should be treated as never receiving shadows.
void | setRenderableListener (RenderableListener *listener)
| Set a renderable listener on the queue.
RenderableListener * | getRenderableListener (void) const

## Protected Attributes

RenderQueueGroupMap | mGroups
uint8 | mDefaultQueueGroup
| The current default queue group.
ushort | mDefaultRenderablePriority
| The default priority.
bool | mSplitPassesByLightingType
bool | mSplitNoShadowPasses
bool | mShadowCastersCannotBeReceivers
RenderableListener * | mRenderableListener

## Classes

class | RenderableListener
| Class to listen in on items being added to the render queue. More...

## Detailed Description

Class to manage the scene object rendering queue.

Remarks:
  Objects are grouped by material to minimise rendering state changes. The map from material to renderable object is wrapped in a class for ease of use.

  This class now includes the concept of 'queue groups' which allows the application adding the renderable to specifically schedule it so that it is included in a discrete group. Good for separating renderables into the main scene, backgrounds and overlays, and also could be used in the future for more complex multipass routines like stenciling.

Definition at line 82 of file OgreRenderQueue.h.

## Member Typedef Documentation

typedef MapIterator<RenderQueueGroupMap> Ogre::RenderQueue::QueueGroupIterator

| Iterator over queue groups. Definition at line 87 of file OgreRenderQueue.h.

typedef std::map< uint8, RenderQueueGroup* > Ogre::RenderQueue::RenderQueueGroupMap

| Definition at line 85 of file OgreRenderQueue.h.

## Constructor & Destructor Documentation

Ogre::RenderQueue::RenderQueue | ( |  | ) |

virtual Ogre::RenderQueue::~RenderQueue | ( |  | ) | `[virtual]`

## Member Function Documentation

QueueGroupIterator Ogre::RenderQueue::_getQueueGroupIterator | ( | void |  | ) |

| Internal method, returns an iterator for the queue groups.

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend | ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a queue or priority to be specified. The queue group is taken from the current default (see setDefaultQueueGroup). The queue priority is take from the current default (see setDefaultRenderablePriority).

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  | pRend | Pointer to the Renderable to be added to the queue

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | uint8 | groupId
| ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a priority to be specified. The queue priority is take from the current default (see setDefaultRenderablePriority).

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  | pRend | Pointer to the Renderable to be added to the queue
  | groupID | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | uint8 | groupID,
|  | ushort | priority
| ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the advanced version of the call which allows the renderable to be added to any queue.

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  | pRend | Pointer to the Renderable to be added to the queue
  | groupID | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.
  | priority | Controls the priority of the renderable within the queue group. If this number is raised, the renderable will be rendered later in the group compared to it's peers. Don't use this unless you really need to, manually ordering renderables prevents OGRE from sorting them for best efficiency. However this could be useful for ordering 2D elements manually for example.

void Ogre::RenderQueue::clear | ( | bool | destroyPassMaps = `false` | ) |

Empty the queue - should only be called by SceneManagers.

Parameters:

  | destroyPassMaps | Set to true to destroy all pass maps so that the queue is completely clean (useful when switching scene managers)

uint8 Ogre::RenderQueue::getDefaultQueueGroup | ( | void |  | ) | const

| Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

ushort Ogre::RenderQueue::getDefaultRenderablePriority | ( | void |  | ) | const

| Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

RenderQueueGroup* Ogre::RenderQueue::getQueueGroup | ( | uint8 | qid | ) |

Get a render queue group.

Remarks:
  OGRE registers new queue groups as they are requested, therefore this method will always return a valid group.

RenderableListener* Ogre::RenderQueue::getRenderableListener | ( | void |  | ) | const

| Definition at line 249 of file OgreRenderQueue.h.

void Ogre::RenderQueue::setDefaultQueueGroup | ( | uint8 | grp | ) |

| Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

void Ogre::RenderQueue::setDefaultRenderablePriority | ( | ushort | priority | ) |

| Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

void Ogre::RenderQueue::setRenderableListener | ( | RenderableListener * | listener | ) |

Set a renderable listener on the queue.

Remarks:
  There can only be a single renderable listener on the queue, since that listener has complete control over the techniques in use.

Definition at line 246 of file OgreRenderQueue.h.

void Ogre::RenderQueue::setShadowCastersCannotBeReceivers | ( | bool | ind | ) |

| Sets whether or not objects which cast shadows should be treated as never receiving shadows.

void Ogre::RenderQueue::setSplitNoShadowPasses | ( | bool | split | ) |

| Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.

void Ogre::RenderQueue::setSplitPassesByLightingType | ( | bool | split | ) |

| Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.

## Member Data Documentation

uint8 Ogre::RenderQueue::mDefaultQueueGroup`[protected]`

| The current default queue group. Definition at line 121 of file OgreRenderQueue.h.

ushort Ogre::RenderQueue::mDefaultRenderablePriority`[protected]`

| The default priority. Definition at line 123 of file OgreRenderQueue.h.

RenderQueueGroupMap Ogre::RenderQueue::mGroups`[protected]`

| Definition at line 119 of file OgreRenderQueue.h.

RenderableListener* Ogre::RenderQueue::mRenderableListener`[protected]`

| Definition at line 129 of file OgreRenderQueue.h.

bool Ogre::RenderQueue::mShadowCastersCannotBeReceivers`[protected]`

| Definition at line 127 of file OgreRenderQueue.h.

bool Ogre::RenderQueue::mSplitNoShadowPasses`[protected]`

| Definition at line 126 of file OgreRenderQueue.h.

bool Ogre::RenderQueue::mSplitPassesByLightingType`[protected]`

| Definition at line 125 of file OgreRenderQueue.h.

The documentation for this class was generated from the following file:

- OgreRenderQueue.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:00 2008